package mx.italika.prod.italika.controller;

import java.util.List;

import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import mx.italika.prod.italika.model.entity.ProductoEntity;
import mx.italika.prod.italika.service.ProductoServiceImpl;

/**
 * Itzi Enriquez 
 */
@RestController
@RequestMapping("/api/v1/productos")
public class ProductoController {

	
	private ProductoServiceImpl productoService;

    
    public ProductoController(ProductoServiceImpl productoService) {
        this.productoService = productoService;
    }

	@GetMapping
	public List<ProductoEntity> listarProductos() {
		return productoService.obtenerTodos();
	}

	@PostMapping("/crear")
	public ResponseEntity<String> crearProducto(@RequestBody ProductoEntity producto) {
		productoService.crearProducto(producto);
		return ResponseEntity.ok("Producto creado exitosamente");
	}

	
	@PutMapping("/{id}")
	public ResponseEntity<?> actualizarProducto(@PathVariable Long id, @RequestBody ProductoEntity producto) {
		return productoService.actualizarProducto(id, producto);
	}

	@DeleteMapping("/{id}")
	public ResponseEntity<?> eliminarProducto(@PathVariable Long id) {
		
		return productoService.eliminarProducto(id);
	}
}