package mx.italika.prod.italika.repository;

import java.util.List;
import java.util.Optional;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.query.Procedure;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import mx.italika.prod.italika.model.entity.ProductoEntity;
/**
 * Itzi Enriquez 
 */
@Transactional
@Repository
public interface ProductoRepository extends JpaRepository<ProductoEntity, Long> {

    @Transactional
    @Procedure(procedureName = "sp_obtener_productos")
    List<ProductoEntity> obtenerTodosLosProductos();

    @Procedure(procedureName = "sp_obtener_producto_por_id")
    Optional<ProductoEntity> obtenerProductoPorId(Long p_id_producto);

    @Procedure(procedureName = "sp_crear_producto")
    void crearProducto(String p_nombre, String p_descripcion, Double p_precio, Integer p_cantidad);

    @Procedure(procedureName = "sp_actualizar_producto")
    void actualizarProducto(Long p_id_producto, String p_nombre, String p_descripcion, Double p_precio, Integer p_cantidad);

    @Procedure(procedureName = "sp_eliminar_producto")
    void eliminarProducto(Long p_id_producto);

}